attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;
attribute vec2 a_normalCoord;

uniform float u_sOffset;
uniform float u_tOffset;
uniform int u_Rotated;

#ifdef GL_ES
varying lowp vec4 v_fragmentColor;
varying mediump vec2 v_texCoord;
//lowp, since right now we're hardcoding the normal coordinates to [0-1] values only
varying lowp vec2 v_normalCoord;

#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 v_normalCoord;
#endif

void main()
{
    gl_Position = CC_PMatrix * a_position;
    v_fragmentColor = a_color;
    v_texCoord = a_texCoord;
	
	float sTest = v_texCoord.s - u_sOffset;
	float tTest = v_texCoord.t - u_tOffset;
	
	if(sTest > 0.0)
	{
		sTest = 1.0;
	}
	else
	{
		sTest = 0.0;
	}
	if(tTest > 0.0)
	{
		tTest = 1.0;
	}
	else
	{
		tTest = 0.0;
	}
	
	
	if(u_Rotated == 1)
	{
		if(sTest == 0.0 && tTest == 0.0) //bottom-left
		{
		v_normalCoord = vec2(0.0, 1.0);
			//v_normalCoord = vec2(0.0, 0.0);
		}
		else if(sTest == 0.0 && tTest == 1.0) //bottom-right
		{
		v_normalCoord = vec2(1.0, 1.0);
			//v_normalCoord = vec2(0.0, 1.0);
		}
		else if(sTest == 1.0 && tTest == 1.0) // top-right
		{
		v_normalCoord = vec2(1.0, 0.0);
		
			//v_normalCoord = vec2(1.0, 1.0);
		}
		else if(sTest == 1.0 && tTest == 0.0) //top-left
		{
		v_normalCoord = vec2(0.0, 0.0);
		
			//v_normalCoord = vec2(1.0, 0.0);
		}
		//v_normalCoord = vec2(0,0);
		//v_normalCoord = vec2(sTest, tTest);
	}
	else
	{
		v_normalCoord = vec2(sTest, tTest);
	}
}