#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec2 v_normalCoord;

uniform vec2  u_contentSize;
uniform sampler2D u_normalMap;
//uniform sampler2D CC_Texture0;

uniform lowp vec3  u_lightPosInLocalSpace_0;
uniform lowp vec3  u_lightPosInLocalSpace_1;
uniform lowp vec3  u_lightPosInLocalSpace_2;
uniform lowp vec3  u_lightPosInLocalSpace_3;
uniform lowp vec3  u_lightPosInLocalSpace_4;
uniform lowp vec3  u_lightPosInLocalSpace_5;
uniform lowp vec3  u_lightPosInLocalSpace_6;
uniform lowp vec3  u_lightPosInLocalSpace_7;
uniform lowp vec3  u_lightPosInLocalSpace_8;
uniform lowp vec3  u_lightPosInLocalSpace_9;
uniform lowp vec4  u_lightInfo_0;
uniform lowp vec4  u_lightInfo_1;
uniform lowp vec4  u_lightInfo_2;
uniform lowp vec4  u_lightInfo_3;
uniform lowp vec4  u_lightInfo_4;
uniform lowp vec4  u_lightInfo_5;
uniform lowp vec4  u_lightInfo_6;
uniform lowp vec4  u_lightInfo_7;
uniform lowp vec4  u_lightInfo_8;
uniform lowp vec4  u_lightInfo_9;


vec3 CalculateLightByIndex(in vec3 inLight, in vec3 normalInfo, in vec3 curPos, in vec4 lightInfo, in vec3 lightPosition)
{
	//lowp vec3 lightDir = 
	lowp vec3 posToLight= -normalize(curPos-lightPosition);
	lowp float normDotPosToLight=max(0.0,dot(normalInfo,posToLight));

	lowp vec3 diffuse = normDotPosToLight*lightInfo.xyz;
	diffuse = diffuse * lightInfo.w; //brightness modifier

	inLight = diffuse + inLight;

	return inLight;
}


void main()
{
    lowp vec4 albedo = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	
	lowp vec3 normal = texture2D(u_normalMap, v_normalCoord).rgb;
	normal = normal * 2.0 - 1.0; //translating normal map colour to vector values
	normal.y = -normal.y;
    normal=normalize(normal);

	//position of this fragment in world coordinates
	lowp vec3 curPos = vec3(v_normalCoord.x*u_contentSize.x,(1.0-v_normalCoord.y)*u_contentSize.y,0.0);
	
	
	lowp vec3 totalLight = vec3(0.9, 0.9, 0.9);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_0, u_lightPosInLocalSpace_0);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_1, u_lightPosInLocalSpace_1);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_2, u_lightPosInLocalSpace_2);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_3, u_lightPosInLocalSpace_3);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_4, u_lightPosInLocalSpace_4);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_5, u_lightPosInLocalSpace_5);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_6, u_lightPosInLocalSpace_6);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_7, u_lightPosInLocalSpace_7);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_8, u_lightPosInLocalSpace_8);
	totalLight = CalculateLightByIndex(totalLight, normal, curPos, u_lightInfo_9, u_lightPosInLocalSpace_9);

	gl_FragColor = albedo*vec4(totalLight, 1.0);
}


